---
title: Docker
description: Docker Collector Plugin
---

import Plugin from '@site/src/components/Plugins';

Collect Docker images from a repository.

<Plugin transferTag="hoppr.core_plugins.collect_docker_plugin">
{
`  process_timeout: 300
`
}
</Plugin>

### Configuration Options

| Option          | Details                                                        |
| --------------- | -------------------------------------------------------------|
| skopeo_command  | String.  Defaults to `skopeo`.  Command to be used to execute skopeo commands.  May be overridden with another command that uses the same syntax, or a fully qualified path if `skopeo` is not on the default `$PATH`. |
| process_timeout | Number of seconds to attempt collect before timeout.  **Default:** 300 |

:::note[System Dependencies]

Certain Linux distributions may require additional configuration.
See the [installation page](../../../using-hoppr/installation.md#install-skopeo) for more information.

:::

### Proxy and Certificate Configuration

The Docker Collector plugin uses Skopeo to download container images, so the proxy and certificate configurations are not handled directly by the plugin, instead they must be configured as specified by Skopeo and its dependencies.

To configure proxies, set the following environment variables:

| Environment Variable Name | Description
|---------------------------|------------
| `http_proxy`              | Proxy for the HTTP protocol.
| `https_proxy`             | Proxy for the HTTPS protocol.
| `no_proxy`                | Comma-separated list of domains where proxies won't be used.

Skopeo uses the `containers/image` library, so for specifying certificates, a custom TLS configuration for a container registry can be configured by creating a directory under `$HOME/.config/containers/certs.d` or `/etc/containers/certs.d`. The name of the directory must correspond to the `host:port` of the registry (e.g., `my-registry.com:5000`). For more details, see [https://github.com/containers/image/blob/main/docs/containers-certs.d.5.md].

### Credentials Configuration

To specify credentials, you need a [credentials file](../../tutorials/processing-101.md#credentials).

Sample credentials file:

```yaml
---
schemaVersion: v1
kind: Credentials

metadata:
  name: Registry Credentials
  version: v1
  description: Sample credentials file

credential_required_services:
  - url: registry.gitlab.com
    user_env: CI_REGISTRY_USER
    pass_env: CI_REGISTRY_PASSWORD
```

### SBOM Generation Tools

- [syft](https://github.com/anchore/syft) (cli tool)
- [sbom-cli-plugin](https://github.com/docker/sbom-cli-plugin) (cli tool)

:::note
For more tools visit the [CycloneDX Tool Center](https://cyclonedx.org/tool-center/)
:::
